// Tyson Hesse Sonic for Sonic Robo Blast 2 by BlueM, abilities by RubyTheMii and Scarf The Wolf

// You are NOT allowed to use this code without my, Scarf's and BlueM's permission.

// Primary ability - the Levi-Dash.
-- Press Jump mid-air to charge up a mid-air Spin Dash that reduces vertical momentum and skips across the surface of water.

-- Let's not get ahead of ourselves, though. We need a check to prevent the ability's instant activation upon jumping.
addHook("AbilitySpecial", function(player)
	player.hesse_useddash = $ or false
	player.hesse_usingdash = $ or false -- to replace PF_THOKKED
	if player.mo and player.mo.skin == "hessesonic" and player.hesse_useddash == false
		player.pflags = $1 & ~PF_SPINNING
		player.hesse_usingdash = true
		player.mo.state = S_PLAY_SPINDASH
		S_StartSound(player.mo, sfx_spndsh)
		for i = 0, 8
			local thdust = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
			if player.mo.eflags & MFE_UNDERWATER or (player.powers[pw_shield] & SH_PROTECTWATER and not player.powers[pw_shield] & SH_PROTECTFIRE)
			   thdust.state = S_SPINDUST_BUBBLE1
			else
			   if player.powers[pw_shield] & SH_PROTECTFIRE
			      thdust.state = S_SPINDUST_FIRE1
			   end
			end
			P_Thrust(thdust, i*ANGLE_45, player.mo.scale * -20)
		end
		if (player.mo.eflags & MFE_UNDERWATER)
		   P_SetObjectMomZ(player.mo, 15*FRACUNIT/2, false)
		else
		   P_SetObjectMomZ(player.mo, 15*FRACUNIT, false)
	    end
	end
end)

addHook("PlayerThink", function(player)
	player.hesse_levidash = $ or false; player.hesse_levipower = $ or 0; player.hesse_useddash = $ or false
	player.hesse_usingdash = $ or false
	if player.mo.eflags & MFE_JUSTHITFLOOR or P_IsObjectOnGround(player.mo)
	   player.hesse_usingdash = false; player.hesse_useddash = false; player.hesse_levipower = 10
	end
	if player.mo and player.mo.skin == "hessesonic" and player.hesse_usingdash == true and player.hesse_useddash == false
		if player.pflags & PF_JUMPDOWN
			player.jumpdown = true
			player.hesse_levidash = true
			if FixedHypot(player.mo.momx, player.mo.momy) >= 30*FRACUNIT
				player.mo.momz = $*9/10
			else
				player.mo.momz = $*10/11
			end
		else
			player.jumpdown = false
		end
		if player.hesse_levidash == true
			player.mo.tyssondrpdsh2 = 0
			player.mo.tyssondrpdsh = 0
			player.mo.spindowndrpdh = 1
			if leveltime % 15 == 0
				player.hesse_levipower = $ + 5
			end
		end
		if (player.hesse_levipower == 30 and not player.powers[pw_super]) or (player.powers[pw_super] and player.hesse_levipower == 60)
			player.hesse_levidash = false; player.hesse_usingdash = false; player.hesse_useddash = true
			player.mo.state = S_PLAY_FALL; player.pflags = $ & ~PF_JUMPED; S_StartSound(player.mo, sfx_s3k51)
			player.hesse_levipower = 10
		end
		if player.hesse_levipower <= 30
			if leveltime % 15 == 0
				S_StartSound(player.mo, sfx_spndsh)
			end
		end
		if player.hesse_levidash == true and player.pflags & PF_JUMPDOWN == 0
			S_StartSound(player.mo, sfx_zoom)
			for i = 0, 8
			   local thdust = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPINDUST)
			   if player.mo.eflags & MFE_UNDERWATER or (player.powers[pw_shield] & SH_PROTECTWATER and not player.powers[pw_shield] & SH_PROTECTFIRE)
			      thdust.state = S_SPINDUST_BUBBLE1
			   else
			      if player.powers[pw_shield] & SH_PROTECTFIRE
			         thdust.state = S_SPINDUST_FIRE1
			      end
			   end
			   P_Thrust(thdust, i*ANGLE_45, player.mo.scale * -20)
			end
			if player.powers[pw_super]
			   if player.mo.eflags & MFE_UNDERWATER
			   	  P_SetObjectMomZ(player.mo, 8*FRACUNIT, false)
				  P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT+player.hesse_levipower)
			   else
			      P_SetObjectMomZ(player.mo, 16*FRACUNIT, false)
				  P_InstaThrust(player.mo, player.mo.angle, 60*FRACUNIT+player.hesse_levipower)
			   end
			   -- Watch out - screen flashing!
			   P_FlashPal(player, PAL_WHITE, TICRATE/6)
			   P_RadiusAttack(player.mo, player.mo, 1500*FRACUNIT)
			else
			   if player.mo.eflags & MFE_UNDERWATER
			      P_SetObjectMomZ(player.mo, 8*FRACUNIT/2, false)
				  P_InstaThrust(player.mo, player.mo.angle, 20*FRACUNIT+player.hesse_levipower)
               else
			      P_SetObjectMomZ(player.mo, 8*FRACUNIT, false)
				  P_InstaThrust(player.mo, player.mo.angle, 40*FRACUNIT+player.hesse_levipower)
			   end
			end
			player.mo.state = S_PLAY_ROLL; player.hesse_levidash = false; player.hesse_usingdash = false; player.hesse_useddash = true
			player.hesse_levipower = 10; player.mo.spindowndrpdh = 0; player.mo.spindowndrpdh2 = 0
			player.mo.tyssondrpdsh = 0; player.mo.tyssondrpdsh2 = 0
		end
		if player.hesse_levidash == true and player.mo.eflags & MFE_TOUCHWATER and FixedHypot(player.mo.momx, player.mo.momy) >= 24*FRACUNIT
			P_SetObjectMomZ(player.mo, 7*FRACUNIT, false)
			S_StartSound(player.mo, sfx_splish)
			P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SPLISH)
			player.hesse_levipower = 10
		end
	end
end)

freeslot("sfx_mchdsh")
// Secondary ability - Mach Speed Mode.
-- Run for a while to activate Boost Mode and run for a few more seconds while in Boost Mode to activate a stronger version.
addHook("PlayerThink", function(player)
   player.hesse_machtics = $ or 0; player.hesse_machmode = $ or false
   if player.mo and player.mo.skin == "hessesonic"
      if player.dashmode >= 3*TICRATE
	     if player.hesse_machtics < 5*TICRATE
			 if P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR
				if not (player.pflags & PF_STARTDASH)
				and not player.exiting
				and player.playerstate == PST_LIVE
				and not player.powers[pw_carry]
				and not (player.mo.eflags & MFE_UNDERWATER)
					local dust = P_SpawnMobj(player.mo.x+(P_RandomRange(-25, 25)*FRACUNIT), player.mo.y, player.mo.floorz, MT_SPINDUST)
					dust.scale = $*P_RandomRange(1/2, 3/2)
					if player.mo.eflags & MFE_VERTICALFLIP
					   dust.z = player.mo.ceilingz - 4*FRACUNIT
					else
					   dust.z = player.mo.floorz
					end
				end
			 end
		 end
		 if FixedHypot(player.mo.momx, player.mo.momy) >= 32*FRACUNIT or (player.pflags & PF_STARTDASH)
	        player.hesse_machtics = $+1
		 end
	  else
	     player.hesse_machtics = 0
		 player.hesse_machmode = false
		 if S_SoundPlaying(player.mo, sfx_cdfm44)
		    S_StopSoundByID(player.mo, sfx_cdfm44)
		 end
	  end
	  if player.hesse_machtics == 4*TICRATE
	     if not S_SoundPlaying(player.mo, sfx_cdfm44)
	        S_StartSound(player.mo, sfx_cdfm44)
		 end
	  elseif player.hesse_machtics == 5*TICRATE
	     if player.powers[pw_super]
		    S_StartSound(player.mo, sfx_s3k9f); S_StartSound(player.mo, sfx_bkpoof); S_StartSound(player.mo, sfx_s227)
		 else
	        S_StartSound(player.mo, sfx_mchdsh); S_StartSound(player.mo, sfx_cdfm35)
		 end
		 local hessering = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
		 hessering.state, hessering.angle = S_FACESTABBERSPEAR, player.drawangle+ANGLE_90
		 hessering.blendmode, hessering.color = AST_ADD, SKINCOLOR_SILVER
		 hessering.destscale, hessering.fuse, hessering.tics = hessering.scale*2, 5, 20
		 if not (player.pflags & PF_STARTDASH)
			if not (player.mo.eflags & MFE_UNDERWATER)
				P_InstaThrust(player.mo, player.mo.angle, FixedHypot(player.mo.momx, player.mo.momy)+24*FRACUNIT)
			else
				P_InstaThrust(player.mo, player.mo.angle, FixedHypot(player.mo.momx, player.mo.momy)+24*FRACUNIT/2)
			end
		 end
		 player.hesse_machmode = true
	  end
	  if (player.hesse_machtics == 6*TICRATE and not player.powers[pw_super]) or (player.hesse_machtics == 5*TICRATE and player.powers[pw_super])
	     player.normalspeed = 45*FRACUNIT
	  elseif (player.hesse_machtics == 7*TICRATE and not player.powers[pw_super]) or (player.hesse_machtics == 6*TICRATE and player.powers[pw_super])
	     player.normalspeed = 55*FRACUNIT
	  elseif (player.hesse_machtics == 8*TICRATE and not player.powers[pw_super]) or (player.hesse_machtics == 7*TICRATE and player.powers[pw_super])
	     player.normalspeed = 65*FRACUNIT
	  elseif (player.hesse_machtics == 8*TICRATE and player.powers[pw_super])
	     player.normalspeed = 80*FRACUNIT
	  elseif player.hesse_machtics == 0
	     player.normalspeed = 35*FRACUNIT
	  end
	  if player.dashmode >= 3*TICRATE
		//but
		if not player.hesse_machmode
			if (leveltime % 5) == 1
				local thesserun = P_SpawnGhostMobj(player.mo)
				thesserun.color = player.mo.color
				thesserun.colorized = true
				thesserun.fuse = 4
				thesserun.blendmode = AST_ADD
				thesserun.frame = ($1 & ~FF_TRANSMASK)|FF_TRANS40
				thesserun.eflags = player.mo.eflags & MFE_VERTICALFLIP
			end
		end
	  end
	  if player.hesse_machmode == true
	     player.charflags = $1|SF_RUNONWATER
		 -- Screen shaking! Y'know, to emphasize Super Sonic's power.
		 if player.powers[pw_super]
		    if leveltime % 8 == 0
			   P_StartQuake(2*FRACUNIT, TICRATE/2)
			end
			if leveltime % 6 == 0
			   local hessering2 = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
			   hessering2.state, hessering2.angle = S_FACESTABBERSPEAR, player.drawangle+ANGLE_90
			   hessering2.blendmode, hessering2.color = AST_ADD, SKINCOLOR_SUPERGOLD1
			   hessering2.destscale, hessering2.fuse, hessering2.tics = hessering2.scale*2, 5, 20
			end
	     end
		 if P_IsObjectOnGround(player.mo) or player.mo.eflags & MFE_JUSTHITFLOOR
			if not (player.pflags & PF_STARTDASH)
			and not player.exiting
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not (player.mo.eflags & MFE_UNDERWATER)
				local dust2 = P_SpawnMobj(player.mo.x+(P_RandomRange(-15, 15)*FRACUNIT), player.mo.y, player.mo.floorz, MT_SPINDUST)
				dust2.scale = $*P_RandomRange(3/2, 3)
				if player.mo.eflags & MFE_VERTICALFLIP
				   dust2.z = player.mo.ceilingz - 4*FRACUNIT
				else
				   dust2.z = player.mo.floorz
				end
			end
		 end
		 player.pflags = $|PF_DRILLING
		 player.drawangle = R_PointToAngle2(player.mo.x, player.mo.y, player.mo.x+player.mo.momx, player.mo.y+player.mo.momy)
		 player.momangle2 = R_PointToAngle2(0,0,player.mo.momx,player.mo.momy)
		 player.camerascale = skins[player.mo.skin].camerascale*5/4
		 local tyssonparticle = P_SpawnMobjFromMobj(player.mo,
		 P_RandomRange(-20, 20)*FRACUNIT,
		 P_RandomRange(-20, 20)*FRACUNIT,
		 P_RandomRange(0, 50)*FRACUNIT, MT_THOK)
		 tyssonparticle.state = S_TYSSON_PARTICLE
		 tyssonparticle.color = player.mo.color
		 tyssonparticle.colorized = true
		 tyssonparticle.fuse = 8
		 tyssonparticle.destscale = 0
		 tyssonparticle.momz = 2
		 if P_IsObjectOnGround(player.mo)
			if not (player.pflags & PF_STARTDASH)
			and not player.exiting
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not (player.mo.eflags & MFE_UNDERWATER)
				 if (player.cmd.forwardmove or player.cmd.sidemove)
					if FixedHypot(player.mo.momx, player.mo.momy) >= player.runspeed
						 if player.powers[pw_sneakers] or player.powers[pw_super]
							if FixedHypot(player.mo.momx, player.mo.momy) <= 80*player.mo.scale
								P_Thrust(player.mo, player.mo.angle, 80*player.mo.scale-FixedHypot(player.mo.momx, player.mo.momy))
							end
						else
							if FixedHypot(player.mo.momx, player.mo.momy) <= 60*player.mo.scale
								P_Thrust(player.mo, player.mo.angle, 60*player.mo.scale-FixedHypot(player.mo.momx, player.mo.momy))
							end
						end
					end
				end
			end
		end
		if (leveltime % 10) == 8
			if not (player.pflags & PF_STARTDASH)
			and not player.exiting
			and player.playerstate == PST_LIVE
			and not player.powers[pw_carry]
			and not (player.mo.eflags & MFE_UNDERWATER)
				local tyssonmode = P_SpawnGhostMobj(player.mo) 
				if tyssonmode and tyssonmode.valid
					tyssonmode.color = player.mo.color
					tyssonmode.colorized = true
					tyssonmode.destscale = $ * 2
					tyssonmode.blendmode = AST_ADD
					tyssonmode.target = player.mo
				end
			end
		end
	  else
	     player.charflags = $ & ~SF_RUNONWATER
		 player.momangle2 = player.mo.angle
		 if player.camerascale == skins[player.mo.skin].camerascale*5/4
		   player.camerascale = skins[player.mo.skin].camerascale
		 end
		 if (player.pflags & PF_DRILLING)
		   player.pflags = $ & ~PF_DRILLING
		  end
	  end
   end
end)

local function ManiaFixedLerp(a, b, w)
    return FixedMul((FRACUNIT - w), a) + FixedMul(w, b)
end

addHook("PostThinkFrame", function()
	for player in players.iterate()
		local mo = player.mo
		if not (mo and mo.valid and mo.skin == "hessesonic") continue end
		if (player == nil) or (player.playerstate != PST_LIVE) continue end
		
	//here's some changes made by SuperPhanto
		if player.dashmode >= 3*TICRATE
			player.nomoredashmodeflash = P_SpawnMobjFromMobj(player.mo,0,0,0,MT_OVERLAY)
			player.nomoredashmodeflash.target = player.mo
			player.nomoredashmodeflash.skin = player.mo.skin
			player.nomoredashmodeflash.sprite = player.mo.sprite
			player.nomoredashmodeflash.spritexscale = player.mo.spritexscale
			player.nomoredashmodeflash.spriteyscale = player.mo.spriteyscale
			player.nomoredashmodeflash.sprite2 = player.mo.sprite2
			player.nomoredashmodeflash.color = player.mo.color
			player.nomoredashmodeflash.angle = player.drawangle
			player.nomoredashmodeflash.info.dispoffset = 1
			player.nomoredashmodeflash.frame = player.mo.frame
			player.nomoredashmodeflash.fuse = 1
			if not P_IsObjectOnGround(player.mo)
				player.runspeed = 0
			else
				player.runspeed = skins["hessesonic"].runspeed
			end
		else
			player.runspeed = skins["hessesonic"].runspeed
		end
	
		if player.mo.state == S_PLAY_RUN
			player.mo.tics = 1
		end
	//end of SuperPhanto's changes	
		
		if (mo.maniapreviousx == nil) or (mo.maniapreviousy == nil) or (mo.maniapreviousz == nil)
			mo.maniapreviousx = mo.x
			mo.maniapreviousy = mo.y
			mo.maniapreviousz = mo.z
		end
		//Used Rebound Dash
		if player.hesse_machmode == true
		and not player.exiting
			for i = 0, 9
				local percent = FRACUNIT * (i * 10) / 100
				local trail = P_SpawnGhostMobj(mo)
				local maniatx = ManiaFixedLerp(mo.x,mo.maniapreviousx,percent)
				local maniaty = ManiaFixedLerp(mo.y,mo.maniapreviousy,percent)
				local maniatz = ManiaFixedLerp(mo.z + 3*FRACUNIT,mo.maniapreviousz + 4*FRACUNIT,percent)
				P_SetOrigin(trail, maniatx, maniaty, maniatz - 7 * FRACUNIT)
				trail.fuse = 4
				trail.color = player.mo.color
				trail.scalespeed = mo.scale/5
				trail.scale = mo.scale - (i * FRACUNIT/120)
				trail.destscale = 0
				trail.blendmode = AST_ADD
				if trail.tracer and trail.tracer.valid
					P_SetOrigin(trail.tracer, maniatx, maniaty, maniatz - 7 * FRACUNIT)
					trail.tracer.fuse = 4
					trail.tracer.color = player.mo.color
					trail.tracer.scalespeed = mo.scale/5
					trail.tracer.scale = mo.scale - (i * FRACUNIT/120)
					trail.tracer.destscale = 0
					trail.tracer.blendmode = AST_ADD
				end
			end
		end
		mo.maniapreviousx = mo.x
		mo.maniapreviousy = mo.y
		mo.maniapreviousz = mo.z
	end
end)

addHook("PlayerCanDamage", function(player)
	if (player.mo.skin == "hessesonic")
		if player.hesse_machmode == true
		or player.mo.state == S_PLAY_TYSSONROLL then
			return true
		end
    end
end)

addHook("TouchSpecial", function(special, toucher)
   special.hessepunt = $ or false
   if special and (special.flags & MF_ENEMY) or (special.flags & MF_MONITOR) and toucher and toucher.skin == "hessesonic"
	  if toucher.player.hesse_machmode == true
	     if toucher.player.powers[pw_super]
		    P_KillMobj(special, special); local bom = P_SpawnMobjFromMobj(special, 0, 0, 0, MT_THOK); bom.state = S_FBOMB_EXPL1
			local boom = P_SpawnMobjFromMobj(special, 0, 0, 0, MT_THOK); boom.state = S_FACESTABBERSPEAR
			boom.blendmode = AST_ADD; boom.color = SKINCOLOR_SILVER; boom.renderflags = $1|RF_FLOORSPRITE
			boom.destscale = $*3; boom.fuse = 8
		 else
	        special.hessepunt = true
		    special.tracer = toucher
		    P_SetObjectMomZ(special, 20*FRACUNIT, false)
		    special.angle = toucher.angle+(P_RandomRange(-45, 45)*ANG1)
		    P_InstaThrust(special, special.angle, -25*FRACUNIT)
		    S_StartSound(toucher, sfx_rail2); S_StartSound(toucher, sfx_dmpain); P_StartQuake(11*FRACUNIT, TICRATE/4)
		 end
		 return true
	  end
   end
end)
addHook("MobjThinker", function(mo)
   if mo and mo.valid
      if mo.hessepunt == true
         mo.rollangle = $+ANG10
		 mo.angle = $+ANGLE_45
	     if mo.eflags & MFE_JUSTHITFLOOR
		    P_KillMobj(mo, mo)
		 end
	  end
   end
end)
addHook("MobjMoveBlocked", function(mo)
   if mo and mo.valid
      if mo.hessepunt == true and not P_IsObjectOnGround(mo)
	     P_BounceMove(mo); S_StartSound(mo, sfx_s3k5d)
	  end
   end
end)
addHook("MobjCollide", function(mo, inf)
  if not (inf.player and inf.skin == "hessesonic" and (inf.player.hesse_machmode == true or inf.player.powers[pw_super]) and (inf.z < mo.z+mo.height and mo.z < inf.z+inf.height)) then return nil end
   mo.health = 0
   S_StartSound(inf, mo.info.deathsound)
   P_KillMobj(mo, inf, inf)
   return false
end, MT_SPIKE)
addHook("MobjCollide", function(mo, inf)
  if not (inf.player and inf.skin == "hessesonic" and (inf.player.hesse_machmode == true or inf.player.powers[pw_super]) and (inf.z < mo.z+mo.height and mo.z < inf.z+inf.height)) then return nil end
   mo.health = 0
   S_StartSound(inf, mo.info.deathsound)
   P_KillMobj(mo, inf, inf)
   return false
end, MT_WALLSPIKE)
		 